<template>
  <q-dialog
    v-model="popupFullSize"
    persistent
    :maximized="maximizedToggle"
    transition-show="slide-up"
    transition-hide="slide-down"
    ref="dialogRef"
  >
    <q-card class="">
      <q-bar>
        <q-space />
        <q-btn
          dense
          flat
          icon="minimize"
          @click="maximizedToggle = false"
          :disable="!maximizedToggle"
        >
          <q-tooltip v-if="maximizedToggle" class="bg-white text-primary"
            >Minimize</q-tooltip
          >
        </q-btn>
        <q-btn
          dense
          flat
          icon="crop_square"
          @click="maximizedToggle = true"
          :disable="maximizedToggle"
        >
          <q-tooltip v-if="!maximizedToggle" class="bg-white text-primary"
            >Maximize</q-tooltip
          >
        </q-btn>
        <q-btn dense flat icon="close" v-close-popup>
          <q-tooltip class="bg-white text-primary">Close</q-tooltip>
        </q-btn>
      </q-bar>
      <q-card-section>
        <div class="text-h6">{{ windowObj.title }}</div>
      </q-card-section>
      <q-card-section class="q-pt-none">
        <div class="dev">
          <p>windowObj.cal: {{ windowObj.cal }}</p>
          <p>windowObj.type: {{ windowObj.type }}</p>
          <p>windowObj.title: {{ windowObj.title }}</p>
          <p>windowObj.fieldId: {{ windowObj.fieldId }}</p>
        </div>
        <form action="">
          <h2>Ajoutez une date</h2>
          <q-btn
            @click.prevent="addCalendar(windowObj.fieldId)"
            label="ajoutez une date"
            type="submit"
            color="primary"
            icon="add"
          />
        </form>
        <form action="">
          <h2>rechercher une date</h2>
          <div class="searchFormFlex">
            <q-input
              filled
              v-model="searchInput"
              label="recherche (yyyy-mm-dd)"
            />
            <q-btn
              @click.prevent="btnSearch()"
              label="recherche"
              type="submit"
              color="primary"
              icon="search"
            />
          </div>
        </form>
        <br><br>
        <ul>
          <li v-for="item in windowObj.cal" :key="item._id" :item="item">
            <q-btn
              @click.prevent="updateCalendar(windowObj.fieldId, item._id)"
              label="modifier"
              type="submit"
              color="primary"
              icon="add"
            />
            {{ item.dateFormat }}: {{ item.value }}
          </li>
        </ul>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>
<script>
import { defineComponent, ref, computed } from 'vue';
import { useQuasar, useDialogPluginComponent } from 'quasar';
import DialogSingleCalendar from 'components/DialogSingleCalendar.vue';

export default defineComponent({

  props: {
    windowObj: {
      type: Object,
      required: true,
    },
    userObject: {
      type: Object,
      required: true,
    },
  },

  emits: [
    ...useDialogPluginComponent.emits,
  ],

  setup(props) {
    const windowObj = computed(() => props.windowObj);
    windowObj.value.calAll = windowObj.value.cal;
    const popupFullSize = ref(true);
    const searchInput = ref();
    const quasar = useQuasar();
    const {
      dialogRef,
      onDialogHide,
    } = useDialogPluginComponent();
    const maximizedToggle = ref(true);

    function calendarAddDateFormat(calendar) {
      const theDate = new Date(calendar.date);
      const year = theDate.getFullYear();
      let month = theDate.getMonth() + 1;
      if (month < 10) {
        month = `0${month}`;
      }
      let day = theDate.getDate();
      if (day < 10) {
        day = `0${day}`;
      }
      calendar.dateFormat = `${year}-${month}-${day}`;
      return calendar;
    }

    function SortArray(y, x) {
      return x.date.localeCompare(y.date);
    }

    async function addCalendar(fieldId) {
      quasar.dialog({
        component: DialogSingleCalendar,
        componentProps: {
          windowObj: { typeCal: 'add', fieldId },
        },
      }).onOk((res) => {
        console.log('OK', res);
        console.log("type === 'POST'");
        windowObj.value.cal.push(res);
        const orderWindowObj = windowObj.value.cal.sort(SortArray);
        windowObj.value.cal = orderWindowObj;
      });
    }
    async function updateCalendar(fieldId, calendarId) {
      const singleCal = props.windowObj.cal.find((calendar) => calendar._id === calendarId);
      quasar.dialog({
        component: DialogSingleCalendar,
        componentProps: {
          windowObj: { typeCal: 'update', calendarId, singleCal },
        },
      }).onOk((res) => {
        if (Array.isArray(res) === true) {
          console.log('OK PUT', res);
          const index = props.windowObj.cal.findIndex((calSingle) => calSingle._id === res[0]._id);
          calendarAddDateFormat(res[0]);
          windowObj.value.cal.splice(index, 1, res[0]);
          console.log(props.windowObj.cal);
          console.log(index);
        } else {
          console.log('OK DELETE', res);
          const index = props.windowObj.cal.findIndex(
            (calSingle) => calSingle._id === res.calendarId,
          );
          windowObj.value.cal.splice(index, 1);
          console.log(props.windowObj.cal);
          console.log(index);
        }
        const orderWindowObj = windowObj.value.cal.sort(SortArray);
        windowObj.value.cal = orderWindowObj;
      });
    }
    function btnSearch() {
      console.log('in func btnSearch', searchInput.value);
      const resultSearch = [];
      for (let index = 0; index < windowObj.value.calAll.length; index += 1) {
        const element = windowObj.value.calAll[index];
        if (element.dateFormat.split(searchInput.value).length - 1 >= 1) {
          resultSearch.push(element);
        }
      }
      console.log('result: ', resultSearch);
      windowObj.value.cal = resultSearch;
    }
    return {
      dialogRef,
      onDialogHide,
      maximizedToggle,
      popupFullSize,
      addCalendar,
      updateCalendar,
      btnSearch,
      searchInput,
      ...props,
    };
  },
});
</script>
<style scoped>
.searchFormFlex{
  display: flex;
  flex-wrap: wrap;
}
.searchFormFlex label{
  min-width: 18rem;
}
</style>
